Index: issm/trunk/src/c/cores/control_core.cpp
===================================================================
--- issm/trunk/src/c/cores/control_core.cpp	(revision 25994)
+++ issm/trunk/src/c/cores/control_core.cpp	(revision 26744)
@@ -143,5 +143,5 @@
 	/*Update control input*/
 	SetControlInputsFromVectorx(femmodel,X);
-	
+
 	/*solve forward: */
 	switch(solution_type){
@@ -152,5 +152,5 @@
 		case StressbalanceSolutionEnum:{
 			femmodel->SetCurrentConfiguration(StressbalanceAnalysisEnum);
-			
+
 			bool is_schur_cg_solver = false;
 			#ifdef _HAVE_PETSC_
@@ -159,5 +159,5 @@
 			if(solver_type==FSSolverEnum) is_schur_cg_solver = true;
 			#endif
-			
+
 			if(is_schur_cg_solver){
 			 solutionsequence_schurcg(femmodel);
@@ -249,8 +249,6 @@
 
 	/*Constrain Gradient*/
-	for(int i=0;i<num_controls;i++){
-		for(int j=0;j<numvertices;j++){
-			G[i*numvertices+j] = scalar*G[i*numvertices+j];
-		}
+	for(int i=0;i<nsize;i++){
+		G[i] = scalar*G[i];
 	}
 
Index: issm/trunk/src/c/cores/controladm1qn3_core.cpp
===================================================================
--- issm/trunk/src/c/cores/controladm1qn3_core.cpp	(revision 25994)
+++ issm/trunk/src/c/cores/controladm1qn3_core.cpp	(revision 26744)
@@ -14,4 +14,5 @@
 extern CoDi_global codi_global;
 #include <sstream> // for output of the CoDiPack tape
+#include <fenv.h>
 void transient_ad(FemModel* femmodel);
 #endif
@@ -75,5 +76,12 @@
 		 * -> These parameters are not read for the CoDiPack ISSM version!
 		 */
+		#if _CODIPACK_MAJOR_==2
+		auto& tape_codi = IssmDouble::getTape();
+		#elif _CODIPACK_MAJOR_==1
 		auto& tape_codi = IssmDouble::getGlobalTape();
+		#else
+		#error "_CODIPACK_MAJOR_ not supported"
+		#endif
+
 		tape_codi.setActive();
 		#if _AD_TAPE_ALLOC_
@@ -88,5 +96,5 @@
 		/*
 		std::stringstream out_s;
-		IssmDouble::getGlobalTape().printStatistics(out_s);
+		IssmDouble::getTape().printStatistics(out_s);
 		_printf0_("StartTrace::Tape Statistics	   : TapeAlloc count=[" << codi_allocn << "]\n" << out_s.str());
 		*/
@@ -153,5 +161,11 @@
 		#endif
 		std::stringstream out_s;
+		#if _CODIPACK_MAJOR_==2
+		IssmDouble::getTape().printStatistics(out_s);
+		#elif _CODIPACK_MAJOR_==1
 		IssmDouble::getGlobalTape().printStatistics(out_s);
+		#else
+		#error "_CODIPACK_MAJOR_ not supported"
+		#endif
 		_printf0_("CoDiPack Profiling::Tape Statistics :\n" << out_s.str());
 		#endif
@@ -159,5 +173,14 @@
 
 	#elif defined(_HAVE_CODIPACK_)
+
+	/*Get Tape*/
+	#if _CODIPACK_MAJOR_==2
+	auto& tape_codi = IssmDouble::getTape();
+	#elif _CODIPACK_MAJOR_==1
 	auto& tape_codi = IssmDouble::getGlobalTape();
+	#else
+	#error "_CODIPACK_MAJOR_ not supported"
+	#endif
+
 	tape_codi.setPassive();
 	if(VerboseAutodiff()){
@@ -239,5 +262,14 @@
 	}
 	#elif defined(_HAVE_CODIPACK_)
+
+	/*Get tape*/
+	#if _CODIPACK_MAJOR_==2
+	auto& tape_codi = IssmDouble::getTape();
+	#elif _CODIPACK_MAJOR_==1
 	auto& tape_codi = IssmDouble::getGlobalTape();
+	#else
+	#error "_CODIPACK_MAJOR_ not supported"
+	#endif
+
 	codi_global.input_indices.clear();
 	if(my_rank==0){
@@ -245,5 +277,12 @@
 			aX[i]=X[i];
 			tape_codi.registerInput(aX[i]);
+			#if _CODIPACK_MAJOR_==2
+			codi_global.input_indices.push_back(aX[i].getIdentifier());
+			#elif _CODIPACK_MAJOR_==1
 			codi_global.input_indices.push_back(aX[i].getGradientData());
+			#else
+			#error "_CODIPACK_MAJOR_ not supported"
+			#endif
+
 		}
 	}
@@ -285,5 +324,11 @@
 			tape_codi.registerOutput(output_value);
 			dependents[i] = output_value.getValue();
+			#if _CODIPACK_MAJOR_==2
+			codi_global.output_indices.push_back(output_value.getIdentifier());
+			#elif _CODIPACK_MAJOR_==1
 			codi_global.output_indices.push_back(output_value.getGradientData());
+			#else
+			#error "_CODIPACK_MAJOR_ not supported"
+			#endif
 
 			#elif defined(_HAVE_ADOLC_)
@@ -377,4 +422,6 @@
 			tape_codi.setGradient(codi_global.output_indices[dep_index],1.0);
 		}
+		//feclearexcept(FE_ALL_EXCEPT);
+		//feenableexcept(FE_DIVBYZERO | FE_INVALID | FE_OVERFLOW);
 		tape_codi.evaluate();
 
@@ -446,4 +493,5 @@
 	}
 	Gnorm = sqrt(Gnorm);
+	_assert_(!xIsNan(Gnorm));
 
 	/*Print info*/
@@ -453,4 +501,5 @@
 
 	/*Clean-up and return*/
+	if(solution_type == TransientSolutionEnum) delete femmodel;
 	*Jlisti = (*Jlisti) +1;
 	xDelete<double>(XU);
Index: issm/trunk/src/c/cores/controlvalidation_core.cpp
===================================================================
--- issm/trunk/src/c/cores/controlvalidation_core.cpp	(revision 25994)
+++ issm/trunk/src/c/cores/controlvalidation_core.cpp	(revision 26744)
@@ -50,5 +50,12 @@
 		 * -> These parameters are not read for the CoDiPack ISSM version!
 		 */
+		#if _CODIPACK_MAJOR_==2
+		auto& tape_codi = IssmDouble::getTape();
+		#elif _CODIPACK_MAJOR_==1
 		auto& tape_codi = IssmDouble::getGlobalTape();
+		#else
+		#error "_CODIPACK_MAJOR_ not supported"
+		#endif
+
 		tape_codi.setActive();
 		#if _AD_TAPE_ALLOC_
@@ -63,5 +70,5 @@
 		/*
 		std::stringstream out_s;
-		IssmDouble::getGlobalTape().printStatistics(out_s);
+		IssmDouble::getTape().printStatistics(out_s);
 		_printf0_("StartTrace::Tape Statistics	   : TapeAlloc count=[" << codi_allocn << "]\n" << out_s.str());
 		*/
@@ -127,5 +134,11 @@
 		#endif
 		std::stringstream out_s;
+		#if _CODIPACK_MAJOR_==2
+		IssmDouble::getTape().printStatistics(out_s);
+		#elif _CODIPACK_MAJOR_==1
 		IssmDouble::getGlobalTape().printStatistics(out_s);
+		#else
+		#error "_CODIPACK_MAJOR_ not supported"
+		#endif
 		_printf0_("CoDiPack Profiling::Tape Statistics :\n" << out_s.str());
 		#endif
@@ -133,5 +146,13 @@
 
 	#elif defined(_HAVE_CODIPACK_)
+
+	#if _CODIPACK_MAJOR_==2
+	auto& tape_codi = IssmDouble::getTape();
+	#elif _CODIPACK_MAJOR_==1
 	auto& tape_codi = IssmDouble::getGlobalTape();
+	#else
+	#error "_CODIPACK_MAJOR_ not supported"
+	#endif
+
 	tape_codi.setPassive();
 	if(VerboseAutodiff()){
@@ -188,7 +209,16 @@
 	/*}}}*/
 	#elif defined(_HAVE_CODIPACK_)
+	/*{{{*/
 	simul_starttrace2(femmodel);
 	IssmDouble* aX=xNew<IssmDouble>(n);
+
+	#if _CODIPACK_MAJOR_==2
+	auto& tape_codi = IssmDouble::getTape();
+	#elif _CODIPACK_MAJOR_==1
 	auto& tape_codi = IssmDouble::getGlobalTape();
+	#else
+	#error "_CODIPACK_MAJOR_ not supported"
+	#endif
+
 	codi_global.input_indices.clear();
 	if(my_rank==0){
@@ -196,5 +226,12 @@
 			aX[i]=X0[i];
 			tape_codi.registerInput(aX[i]);
+			#if _CODIPACK_MAJOR_==2
+			codi_global.input_indices.push_back(aX[i].getIdentifier());
+			#elif _CODIPACK_MAJOR_==1
 			codi_global.input_indices.push_back(aX[i].getGradientData());
+			#else
+			#error "_CODIPACK_MAJOR_ not supported"
+			#endif
+
 		}
 	}
@@ -230,5 +267,12 @@
 			tape_codi.registerOutput(output_value);
 			dependents[i] = output_value.getValue();
+			#if _CODIPACK_MAJOR_==2
+			codi_global.output_indices.push_back(output_value.getIdentifier());
+			#elif _CODIPACK_MAJOR_==1
 			codi_global.output_indices.push_back(output_value.getGradientData());
+			#else
+			#error "_CODIPACK_MAJOR_ not supported"
+			#endif
+
 			J+=output_value;
 		}
@@ -252,5 +296,5 @@
 	/*Clear tape*/
 	tape_codi.reset();
-
+/*}}}*/
 	#else
 	/*{{{*/
Index: issm/trunk/src/c/cores/cores.h
===================================================================
--- issm/trunk/src/c/cores/cores.h	(revision 25994)
+++ issm/trunk/src/c/cores/cores.h	(revision 26744)
@@ -1,4 +1,4 @@
 /*
- * cores.h: 
+ * cores.h:
  */
 
@@ -9,5 +9,5 @@
 class FemModel;
 class Parameters;
-class SealevelMasks;
+class SealevelGeometry;
 template <class doubletype> class Matrix;
 template <class doubletype> class Vector;
@@ -35,4 +35,5 @@
 void controlvalidation_core(FemModel* femmodel);
 void masstransport_core(FemModel* femmodel);
+void oceantransport_core(FemModel* femmodel);
 void depthaverage_core(FemModel* femmodel);
 void extrudefrombase_core(FemModel* femmodel);
@@ -44,4 +45,5 @@
 void steadystate_core(FemModel* femmodel);
 void transient_core(FemModel* femmodel);
+void transient_precore(FemModel* femmodel);
 void dakota_core(FemModel* femmodel);
 void ad_core(FemModel* femmodel);
@@ -54,21 +56,21 @@
 void bmb_core(FemModel* femmodel);
 void damage_core(FemModel* femmodel);
+void sampling_core(FemModel* femmodel);
+
+/*sealevel change cores:*/
+#ifdef _HAVE_SEALEVELCHANGE_
 void sealevelchange_core(FemModel* femmodel);
-void grd_core(FemModel* femmodel);
+void sealevelchange_initialgeometry(FemModel* femmodel);
+SealevelGeometry* sealevelchange_geometry(FemModel* femmodel);
+#endif
+void grd_core(FemModel* femmodel,SealevelGeometry* slgeom);
+void solidearthexternal_core(FemModel* femmodel);
 void dynstr_core(FemModel* femmodel);
-void sealevelrise_core_geometry(FemModel* femmodel);
-SealevelMasks* sealevelrise_core_masks(FemModel* femmodel);
-Vector<IssmDouble>* sealevelrise_core_eustatic(FemModel* femmodel,SealevelMasks* mask, IssmDouble* poceanarea);
-Vector<IssmDouble>* sealevelrise_core_noneustatic(FemModel* femmodel,SealevelMasks* masks, Vector<IssmDouble>* RSLg_eustatic,IssmDouble oceanarea);
-void sealevelrise_core_elastic(Vector<IssmDouble>** pU_radial, Vector<IssmDouble>** pU_north,Vector<IssmDouble>** pU_east,FemModel* femmodel,Vector<IssmDouble>* RSLg, SealevelMasks* masks);
-void sealevelrise_core_viscous(Vector<IssmDouble>** pU_gia,Vector<IssmDouble>** pN_gia,FemModel*  femmodel,Vector<IssmDouble>* RSLg);
-void sealevelrise_diagnostics(FemModel* femmodel,Vector<IssmDouble>* RSLg);
-IssmDouble objectivefunction(IssmDouble search_scalar,FemModel* femmodel);
-void GetStericRate(Vector<IssmDouble> ** psteric_rate_g, FemModel* femmodel);
-void GetDynamicRate(Vector<IssmDouble> ** pdynamic_rate_g, FemModel* femmodel);
-void SetBottomPressure(FemModel* femmodel);
+void couplerinput_core(FemModel* femmodel);
+void coupleroutput_core(FemModel* femmodel);
 
 //optimization
 int GradJSearch(IssmDouble* search_vector,FemModel* femmodel,int step);
+IssmDouble objectivefunction(IssmDouble search_scalar,FemModel* femmodel);
 
 //diverse
@@ -77,12 +79,10 @@
 void ResetBoundaryConditions(FemModel* femmodel, int analysis_type);
 void PrintBanner(void);
-void TransferForcing(FemModel* femmodel,int forcingenum);
-void TransferSealevel(FemModel* femmodel,int forcingenum);
 void EarthMassTransport(FemModel* femmodel);
-void slrconvergence(bool* pconverged, Vector<IssmDouble>* RSLg,Vector<IssmDouble>* RSLg_old,IssmDouble eps_rel,IssmDouble eps_abs);
 
 //solution configuration
 void CorePointerFromSolutionEnum(void (**psolutioncore)(FemModel*),Parameters* parameters,int solutiontype);
 void WrapperCorePointerFromSolutionEnum(void (**psolutioncore)(FemModel*),Parameters* parameters,int solutiontype,bool nodakotacore=false);
+void WrapperPreCorePointerFromSolutionEnum(void (**psolutioncore)(FemModel*),Parameters* parameters,int solutiontype);
 void AdjointCorePointerFromSolutionEnum(void (**padjointcore)(FemModel*),int solutiontype);
 
Index: issm/trunk/src/c/cores/depthaverage_core.cpp
===================================================================
--- issm/trunk/src/c/cores/depthaverage_core.cpp	(revision 25994)
+++ issm/trunk/src/c/cores/depthaverage_core.cpp	(revision 26744)
@@ -23,5 +23,5 @@
 
 	/*If this is a 2D horizontal domain: no need to do anything, just copy input*/
-	if(domaintype==Domain2DhorizontalEnum){
+	if(domaintype==Domain2DhorizontalEnum || domaintype==Domain3DsurfaceEnum){
 		InputDuplicatex(femmodel,inputenum,input_average_enum);
 		return;
Index: issm/trunk/src/c/cores/esa_core.cpp
===================================================================
--- issm/trunk/src/c/cores/esa_core.cpp	(revision 25994)
+++ issm/trunk/src/c/cores/esa_core.cpp	(revision 26744)
@@ -20,5 +20,6 @@
 	Vector<IssmDouble> *U_x   = NULL; 
 	Vector<IssmDouble> *U_y    = NULL; 
-	bool save_results,isesa,iscoupler;
+	bool save_results,isesa;
+	int iscoupler;
 	int domaintype;
 	int solution_type;
@@ -41,5 +42,5 @@
 	femmodel->parameters->FindParam(&save_results,SaveResultsEnum);
 	femmodel->parameters->FindParam(&isesa,TransientIsesaEnum);
-	femmodel->parameters->FindParam(&iscoupler,TransientIscouplerEnum);
+	femmodel->parameters->FindParam(&iscoupler,IsSlcCouplingEnum);
 
 	/* recover coordinates of vertices: */
@@ -113,5 +114,5 @@
 		if(numoutputs){for(int i=0;i<numoutputs;i++){xDelete<char>(requested_outputs[i]);} xDelete<char*>(requested_outputs);}
 	}
-	
+
 	/*End profiler*/
 	femmodel->profiler->Stop(ESACORE);
Index: issm/trunk/src/c/cores/extrudefrombase_core.cpp
===================================================================
--- issm/trunk/src/c/cores/extrudefrombase_core.cpp	(revision 25994)
+++ issm/trunk/src/c/cores/extrudefrombase_core.cpp	(revision 26744)
@@ -21,4 +21,5 @@
 	/*If this is a 2D horizontal domain, return (no need to extrude)*/
 	if(domaintype==Domain2DhorizontalEnum) return;
+	if(domaintype==Domain3DsurfaceEnum) return;
 
 	int inputenum;
Index: issm/trunk/src/c/cores/extrudefromtop_core.cpp
===================================================================
--- issm/trunk/src/c/cores/extrudefromtop_core.cpp	(revision 25994)
+++ issm/trunk/src/c/cores/extrudefromtop_core.cpp	(revision 26744)
@@ -23,4 +23,5 @@
 	/*If this is a 2D horizontal domain, return (no need to extrude)*/
 	if(domaintype==Domain2DhorizontalEnum) return;
+	if(domaintype==Domain3DsurfaceEnum) return;
 
 	/*Special method for Penta, otherwise call solution sequence*/
Index: issm/trunk/src/c/cores/hydrology_core.cpp
===================================================================
--- issm/trunk/src/c/cores/hydrology_core.cpp	(revision 25994)
+++ issm/trunk/src/c/cores/hydrology_core.cpp	(revision 26744)
@@ -9,6 +9,7 @@
 #include "../modules/modules.h"
 #include "../solutionsequences/solutionsequences.h"
-
-void hydrology_core(FemModel* femmodel){
+void SolidEarthWaterUpdates(FemModel* femmodel);
+
+void hydrology_core(FemModel* femmodel){ /*{{{*/
 
 	/*Start profiler*/
@@ -43,4 +44,27 @@
 		/*transfer water column thickness to old water column thickness: */
 		InputDuplicatex(femmodel,WatercolumnEnum,WaterColumnOldEnum);
+		/*solid earth considerations:*/
+		SolidEarthWaterUpdates(femmodel);
+
+	}
+	/*Using the Tws based Model*/
+	if (hydrology_model==HydrologyTwsEnum){
+		if(VerboseSolution()) _printf0_("   computing water column\n");
+
+		femmodel->SetCurrentConfiguration(HydrologyTwsAnalysisEnum);
+
+		/*save current tws  before updating:*/
+		InputDuplicatex(femmodel,WatercolumnEnum,WaterColumnOldEnum);
+
+		/*grab tws from the hydrology.spcwatercolumn field input and update 
+		 * the solution with it:*/
+		Vector<IssmDouble>*  ug  = NULL;
+		GetVectorFromInputsx(&ug,femmodel,HydrologyTwsSpcEnum,VertexPIdEnum);
+		InputUpdateFromSolutionx(femmodel,ug); 
+
+		/*solid earth considerations:*/
+		SolidEarthWaterUpdates(femmodel);
+
+		delete ug;
 
 	}
@@ -147,9 +171,28 @@
 	/*Using the SHAKTI model*/
 	else if (hydrology_model==HydrologyshaktiEnum){
+
+		/*Get second derivatives of gap height*/
+		femmodel->SetCurrentConfiguration(L2ProjectionBaseAnalysisEnum);
+		femmodel->parameters->SetParam(HydrologyGapHeightXEnum,InputToL2ProjectEnum);
+		solutionsequence_linear(femmodel);
+		femmodel->parameters->SetParam(HydrologyGapHeightYEnum,InputToL2ProjectEnum);
+		solutionsequence_linear(femmodel);
+		femmodel->parameters->SetParam(HydrologyGapHeightXXEnum,InputToL2ProjectEnum);
+		solutionsequence_linear(femmodel);
+		femmodel->parameters->SetParam(HydrologyGapHeightYYEnum,InputToL2ProjectEnum);
+		solutionsequence_linear(femmodel);
+
+		/*Update Effective pressure*/
+		if(VerboseSolution()) _printf0_("   computing effective pressure\n");
+		HydrologyShaktiAnalysis* analysis = new HydrologyShaktiAnalysis();
+		analysis->UpdateEffectivePressure(femmodel);
+
+		/*Get new head*/
 		femmodel->SetCurrentConfiguration(HydrologyShaktiAnalysisEnum);
 		InputDuplicatex(femmodel,HydrologyHeadEnum,HydrologyHeadOldEnum);
 		solutionsequence_shakti_nonlinear(femmodel);
+
+		/*Update Gap Height*/
 		if(VerboseSolution()) _printf0_("   updating gap height\n");
-		HydrologyShaktiAnalysis* analysis = new HydrologyShaktiAnalysis();
 		analysis->UpdateGapHeight(femmodel);
 		delete analysis;
@@ -202,3 +245,31 @@
 	/*End profiler*/
 	femmodel->profiler->Stop(HYDROLOGYCORE);
-}
+} /*}}}*/
+void SolidEarthWaterUpdates(FemModel* femmodel){ /*{{{*/
+
+	int isgrd;
+	int grdmodel;
+	IssmDouble time;
+	int frequency,count;
+
+	/*retrieve parameters:*/
+	femmodel->parameters->FindParam(&isgrd,SolidearthSettingsGRDEnum);
+	femmodel->parameters->FindParam(&grdmodel,GrdModelEnum);
+	femmodel->parameters->FindParam(&time,TimeEnum);
+	femmodel->parameters->FindParam(&frequency,SolidearthSettingsRunFrequencyEnum);
+	femmodel->parameters->FindParam(&count,SealevelchangeRunCountEnum);
+
+	/*early return?:*/
+	if(!isgrd)return;
+
+	/*From old and new thickness, create delta thickness  and accumulate:*/
+	femmodel->inputs->ZAXPY(-1, WaterColumnOldEnum,WatercolumnEnum,DeltaTwsEnum);
+	femmodel->inputs->AXPY(+1, DeltaTwsEnum,AccumulatedDeltaTwsEnum);
+
+	/*compute total water column change between two sea-level solver time steps, ie. every frequency*dt:*/
+	if(count==frequency){
+		femmodel->inputs->ZAXPY(-1, OldAccumulatedDeltaTwsEnum,AccumulatedDeltaTwsEnum,DeltaTwsEnum);
+		femmodel->inputs->DuplicateInput(AccumulatedDeltaTwsEnum,OldAccumulatedDeltaTwsEnum);
+	}
+	return;
+}/*}}}*/
